import graphic, random

class Cloud:
    def __init__(self, location, speed, type):
        self.location = location
        self.speed    = speed
        self.type     = type

    def draw(self):
        global image
        graphic.draw(image[self.type], graphic.screen, self.location)

    def update(self):
        self.location = (self.location[0]+self.speed[0], self.location[1]+self.speed[1])

def add_cloud():
    global background_cloud_list, foreground_cloud_list
    if random.randint(0, 2) == 2:
        background = False
    else:
        background = True

    modifier = random.randint(0, 2)
    
    if background == True:
        background_cloud_list += [Cloud((400, random.randint(-250, 400)), (-12+modifier, 8-modifier), random.randint(0,1))]
    else:
        foreground_cloud_list += [Cloud((400, random.randint(-250, 400)), (-16-modifier, 12+modifier), random.randint(0, 1))]

def draw_background():
    global background_cloud_list
    for cloud in background_cloud_list:
        cloud.draw()

def draw_foreground():
    global foreground_cloud_list
    for cloud in foreground_cloud_list:
        cloud.draw()

def update():
    global background_cloud_list, foreground_cloud_list
    x = 0
    while x < len(background_cloud_list):
        background_cloud_list[x].update()
        if background_cloud_list[x].location[1] > 400:
            background_cloud_list.pop(x)
            add_cloud()
        else:
            x+=1

    x = 0
    while x < len(foreground_cloud_list):
        foreground_cloud_list[x].update()
        if foreground_cloud_list[x].location[1] > 400:
            foreground_cloud_list.pop(x)
            add_cloud()
        else:
            x+=1

def init():
    global background_cloud_list, foreground_cloud_list
    global image
    background_cloud_list = []
    foreground_cloud_list = []
    image = [graphic.load_image("cloud_1.png"),
             graphic.load_image("cloud_2.png")]
