import pygame, sys

#-------------------------#
# Module public variables #
#-------------------------#
# clock: clock
# keys:  down, left, right, up, space

down        = pygame.K_DOWN
left        = pygame.K_LEFT
right       = pygame.K_RIGHT
up          = pygame.K_UP
space       = pygame.K_SPACE
printscreen = pygame.K_p


#-----------------------------------#
# Standard parameters for functions #
#-----------------------------------#

#--------------------------------#
#------- Input functions --------#
#--------------------------------#

def get_keys():
    return pygame.key.get_pressed()

#--------------------------------#
#------- Timing functions -------#
#--------------------------------#

def new_frame():
    global clock
    
    #Handles events for each frame
    quit = pygame.event.get(pygame.QUIT)
    if quit:
        sys.exit()
    pygame.event.pump()
    
    clock.tick(40)

#--------------------------------#
#------- Other functions --------#
#--------------------------------#

def init():
    global clock
    clock = pygame.time.Clock()
    pygame.event.set_blocked([pygame.ACTIVEEVENT, pygame.MOUSEMOTION, pygame.MOUSEBUTTONUP, pygame.MOUSEBUTTONDOWN, pygame.JOYAXISMOTION, pygame.JOYBALLMOTION, pygame.JOYHATMOTION, pygame.JOYBUTTONDOWN, pygame.JOYBUTTONUP, pygame.VIDEORESIZE, pygame.VIDEOEXPOSE])
    pygame.event.set_allowed([pygame.KEYDOWN, pygame.KEYUP, pygame.QUIT, pygame.USEREVENT])
