import audio, graphic, math

def distance(p1, p2):
    return math.floor(math.sqrt((p1[0]-p2[0])**2 + (p1[1]-p2[1])**2))

class Gunfire:
    def __init__(self, location, speed, color):
        self.location = location
        self.speed    = speed
        self.color    = color
        self.size     = math.floor(math.sqrt(speed[0]**2 + speed[1]**2))
        self.update()
        self.update()
    
    def draw(self):
        p1 = (self.location[0]-self.speed[0], self.location[1]-self.speed[1])
        p2 = (self.location[0]+self.speed[0], self.location[1]+self.speed[1])
        graphic.draw_line(graphic.screen, p1, p2, self.color)
    
    def update(self):
        self.location = (self.location[0]+self.speed[0], self.location[1]+self.speed[1])

def create(location, speed, color):
    global shots
    shots += [Gunfire(location, speed, color)]

def draw():
    global shots
    for shot in shots:
        shot.draw()

def hits(location, size):
    global shots
    hits = 0
    x = 0
    while x < len(shots):
        if distance(shots[x].location, location) < size + shots[x].size:
            shots.pop(x)
            hits+=1
        else:
            x+=1
    return hits

def update():
    global shots
    x = 0
    while x < len(shots):
        shots[x].update()
        if shots[x].location[0] > 700 or shots[x].location[0] < -50:
            shots.pop(x)
        else:
            x += 1

def init():
    global shots
    shots = []