#!/usr/bin/python

import pygame, audio, cloud, control, enemy, explosion, graphic, gunfire, math, player, stage

def logo():
    logo_img = graphic.load_image("shundread.png")

    audio.play_music("song1.ogg")
    
    graphic.clear_screen()
    for x in xrange(0, 25):
        graphic.update_screen()
        control.new_frame()
    graphic.draw_centered(logo_img, graphic.screen, graphic.screen_center)
    graphic.write_centered("Shundread is ON FIRE!!1 presents:", graphic.screen, (graphic.screen_center[0], graphic.screen_center[1]+2*logo_img.get_size()[1]/3), graphic.font_standard)
    for x in xrange(0, 100):
        graphic.update_screen()
        control.new_frame()
    graphic.clear_screen()
    for x in xrange(0, 25):
        graphic.update_screen()
        control.new_frame()

def story():
    talk_box      = graphic.load_image("talkbox.png")
    stuntsman     = graphic.load_image("stuntsman.png")
    thecaptain    = graphic.load_image("thecaptain.png")
    ground        = graphic.load_image("ground.png")
    rising_ground = graphic.load_image("rising_ground.png")
    cloud1        = graphic.load_image("cloud_1.png")
    cloud2        = graphic.load_image("cloud_2.png")
    title         = graphic.load_image("title.png")
    car           = graphic.load_image("car.png")
    rising_car    = graphic.rotate(car, 30)

    graphic.fade_in()
    graphic.clear_sky()
    for x in xrange(0, 25):
        graphic.update_screen()
        control.new_frame()
    
    graphic.draw(talk_box, graphic.screen, (0, 304))
    graphic.draw(thecaptain, graphic.screen, (304, 304))
    graphic.write_centered("Stuntsman! This is The Captain!", graphic.screen, (152, 332), graphic.font_standard, (0,0,0))
    graphic.write_centered("The martians are invading our  ", graphic.screen, (152, 352), graphic.font_standard, (0,0,0))
    graphic.write_centered("planet! We need your help!     ", graphic.screen, (152, 372), graphic.font_standard, (0,0,0))
    for x in xrange(0, 225):
        graphic.update_screen()
        control.new_frame()

    graphic.clear_sky()
    graphic.draw(ground, graphic.screen, (0, 352))
    graphic.draw(talk_box, graphic.screen, (0,0))
    graphic.draw(stuntsman, graphic.screen, (0,0))
    graphic.write_centered("I'm on my way!", graphic.screen, (248, 48), graphic.font_standard, (0,0,0))
    graphic.update_screen()
    for x in xrange(0, 75):
        graphic.update_screen()
        control.new_frame()
    
    for x in xrange(-10, 70):
        graphic.clear_sky_area(((x*8, 329), (56, 23)))
        graphic.draw(car, graphic.screen, (x*8+8, 329))
        graphic.update_screen()
        control.new_frame()
    for x in xrange(0, 25):
        graphic.update_screen()
        control.new_frame()

    angle = math.radians(-30)
    for x in xrange(-10, 80):
        xpos = 8*x*math.cos(angle)
        ypos = 371+8*x*math.sin(angle)
        graphic.clear_sky()
        graphic.draw(rising_ground, graphic.screen, (43, 218))
        graphic.draw(rising_car, graphic.screen, (xpos, ypos))
        graphic.draw(cloud1, graphic.screen, (50+x/2, 100))
        graphic.draw(cloud1, graphic.screen, (380-x, 300))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 150):
        graphic.clear_sky()
        graphic.draw(rising_ground, graphic.screen, (43, 218))
        graphic.draw(cloud1, graphic.screen, (90+x/2, 100))
        graphic.draw_centered(title, graphic.screen, graphic.screen_center)
        graphic.draw(cloud1, graphic.screen, (300-x, 300))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 200):
        graphic.clear_sky()
        graphic.draw(rising_ground, graphic.screen, (43, 218+x))
        graphic.draw(cloud1,  graphic.screen, (165+x/2, 100+x/2))
        graphic.draw(cloud1,  graphic.screen, (150-x, 300+x))
        graphic.draw(cloud2, graphic.screen, (400-x, 230+x))
        graphic.write_centered("Use arrow keys to control the car", graphic.screen, (200, 100), graphic.font_standard, (0,0,0))
        graphic.write_centered("and space bar to fire", graphic.screen, (200, 120), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

    xspeed = 0.5
    yspeed = 0.5
    xpos = 265.0
    ypos = 200.0
    for x in xrange(0, 50):
        xspeed -= 0.25
        yspeed += 0.15
        xpos += xspeed
        ypos += yspeed
        graphic.clear_sky()
        graphic.draw(cloud1,  graphic.screen, (int(xpos), int(ypos)))
        graphic.write_centered("Use arrow keys to control the car", graphic.screen, (200, 100), graphic.font_standard, (0,0,0))
        graphic.write_centered("and space bar to fire", graphic.screen, (200, 120), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()
    
    for x in xrange(0, 40):
        graphic.clear_sky()
        if x%10 == 0:
            cloud.add_cloud()
        
        cloud.update()
        cloud.draw_background()
        graphic.write_centered("Use arrow keys to control the car", graphic.screen, (200, 100), graphic.font_standard, (0,0,0))
        graphic.write_centered("and space bar to fire", graphic.screen, (200, 120), graphic.font_standard, (0,0,0))
        cloud.draw_foreground()
        graphic.update_screen()
        control.new_frame()
    
    for x in xrange(0, 150):
        graphic.clear_sky()
        cloud.update()
        cloud.draw_background()
        cloud.draw_foreground()
        graphic.update_screen()
        control.new_frame()
    
    for x in xrange(0, 100):
        graphic.clear_sky()
        cloud.update()
        cloud.draw_background()
        graphic.draw_centered(rising_car, graphic.screen, (415-3*x, 200+x))
        cloud.draw_foreground()
        graphic.update_screen()
        control.new_frame()

def game():
    game_over = False
    player.init()
    stage.load(1)
    while game_over == False:
        graphic.clear_sky()
        stage.update()
        player.update()
        enemy.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        enemy.draw()
        explosion.draw()
        stage.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.update_screen()
        if control.get_keys()[control.printscreen]:
            graphic.print_screen()
        control.new_frame()
        # POG
        if player.dead:
            for x in xrange(0, 70):
                graphic.clear_sky()
                enemy.update()
                explosion.update()
                cloud.update()
                gunfire.update()
                player.update()
                cloud.draw_background()
                player.draw()
                enemy.draw()
                explosion.draw()
                gunfire.draw()
                cloud.draw_foreground()
                graphic.update_screen()
                if control.get_keys()[control.printscreen]:
                    graphic.print_screen()
                control.new_frame()
            if player.lives > 0:
                player.reraise()
            else:
                game_over = True

def show_score():
    print "Your score was",player.score

pygame.init()
graphic.init()
audio.init()
cloud.init()
gunfire.init()
explosion.init()
control.init()
stage.init()

logo()
story()
audio.loop_music("song2.ogg")
while True:
    game()
    show_score()