import audio, control, explosion, gunfire, graphic

def draw():
    global dead, image, location
    if dead == False:
        graphic.draw_centered(image, graphic.screen, location)
    draw_info()

def draw_info():
    global lives, hitpoints, score
    graphic.write("Lives:     "+"@"*lives,     graphic.screen, (10, 10), graphic.font_standard, (0,0,0))
    graphic.write("Hitpoints: "+"*"*hitpoints, graphic.screen, (10, 25), graphic.font_standard, (0,0,0))
    graphic.write("Score:     "+str(score),     graphic.screen, (10, 40), graphic.font_standard, (0,0,0))

def update():
    global cooldown, dead, hitpoints, location, lock, size

    keys = control.get_keys()
    if lock == True:
        return
    if dead == True:
        return

    hits = gunfire.hits(location, size)
    if hits > 0:
        hitpoints -= hits
        if hitpoints <= 0:
            dead = True
            explosion.create(location, 0)
            explosion.create((location[0]-3, location[1]+5), -6)
            explosion.create((location[0]+3, location[1]+3), -12)
            explosion.create((location[0]-6, location[1]), -17)
            return
        else:
            audio.player_hit.play()

    xpos = location[0]
    ypos = location[1]
    if keys[control.down]:
        ypos += 6
    if keys[control.left]:
        xpos -= 6
    if keys[control.right]:
        xpos += 6
    if keys[control.up]:
        ypos -= 6
    if keys[control.space]:
        if cooldown < 0:
            audio.bang.play()
            gunfire.create(location, (13, -8), (0,0,0))
            cooldown = 5
    if xpos < 0:
        xpos = 0
    elif xpos > 400:
        xpos = 400
    if ypos < 0:
        ypos = 0
    elif ypos > 400:
        ypos = 400
    location = (xpos, ypos)
    cooldown -= 1

def set_lock(value):
    global lock
    lock = value

def reraise():
    global cooldown, dead, hitpoints, lives, location, lock
    cooldown   = 0
    dead       = False
    hitpoints  = 3
    lives     -= 1
    location   = (115, 300)
    lock       = False

def init():
    global cooldown, dead, explosion_images, hitpoints, image, lives, location, lock, score, size
    cooldown  = 0
    dead      = False
    hitpoints = 5
    image     = graphic.rotate(graphic.load_image("car.png"), 30)
    lives     = 3
    location  = (115, 300)
    lock      = False
    score     = 0
    size      = 12
