import control, cloud, enemy, explosion, gunfire, explosion, graphic, player, os, sys

#--------------------------#
#---- Event structures ----#
#--------------------------#

class Waiter:
    def __init__(self, timer, name):
        self.timer = timer
        self.name  = name
    
    def act(self):
        pass

class Special:
    def __init__(self, timer, name, id):
        self.timer = timer
        self.name  = name
        self.id    = id
    
    def act(self):
        global specials
        specials[self.id]()

class Summon:
    def __init__(self, timer, name, location):
        self.timer    = timer
        self.name     = name
        self.location = location
    
    def act(self):
        enemy.create(self.name, self.location)

#------------------------#
#---- Special events ----#
#------------------------#

def special0():
    talk_box  = graphic.load_image("talkbox.png")
    stuntsman = graphic.load_image("stuntsman.png")

    for x in xrange(0, 150):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(stuntsman, graphic.screen, (0, 304))
        graphic.write_centered("I think this was good enough...", graphic.screen, (248, 352), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 150):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(stuntsman, graphic.screen, (0, 304))
        graphic.write_centered("...for a warm-up!", graphic.screen, (248, 352), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()


def special1():
    talk_box   = graphic.load_image("talkbox.png")
    stuntsman  = graphic.load_image("stuntsman.png")

    for x in xrange(0, 225):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(stuntsman, graphic.screen, (0, 304))
        graphic.write_centered("I've done stunts more dangerous", graphic.screen, (248, 342), graphic.font_standard, (0,0,0))
        graphic.write_centered("than fighting these martians!  ", graphic.screen, (248, 362), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

def special2():
    talk_box   = graphic.load_image("talkbox.png")
    stuntsman  = graphic.load_image("stuntsman.png")
    thecaptain = graphic.load_image("thecaptain.png")

    for x in xrange(0, 275):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(thecaptain, graphic.screen, (304, 304))
        graphic.write_centered("You're getting close to the  ", graphic.screen, (152, 332), graphic.font_standard, (0,0,0))
        graphic.write_centered("mothership. We're counting on", graphic.screen, (152, 352), graphic.font_standard, (0,0,0))
        graphic.write_centered("you, Stuntsman!              ", graphic.screen, (152, 372), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 150):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(stuntsman, graphic.screen, (0, 304))
        graphic.write_centered("Hm!!!", graphic.screen, (248, 352), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

def special3():
    talk_box   = graphic.load_image("talkbox.png")
    stuntsman  = graphic.load_image("stuntsman.png")
    thecaptain = graphic.load_image("thecaptain.png")
    the_end    = graphic.load_image("the_end.png")

    for x in xrange(0, 150):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(thecaptain, graphic.screen, (304, 304))
        graphic.write_centered("Our planet is saved! We love you", graphic.screen, (152, 342), graphic.font_standard, (0,0,0))
        graphic.write_centered("Stuntsman!                      ", graphic.screen, (152, 362), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 200):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw(talk_box,  graphic.screen, (0, 304))
        graphic.draw(stuntsman, graphic.screen, (0, 304))
        graphic.write_centered("This was some good workout!", graphic.screen, (248, 352), graphic.font_standard, (0,0,0))
        graphic.update_screen()
        control.new_frame()

    for x in xrange(0, 300):
        graphic.clear_sky()
        player.update()
        explosion.update()
        cloud.update()
        gunfire.update()
        cloud.draw_background()
        player.draw()
        explosion.draw()
        gunfire.draw()
        cloud.draw_foreground()
        graphic.draw_centered(the_end,  graphic.screen, graphic.screen_center)
        graphic.update_screen()
        control.new_frame()

    sys.exit()

def load(stage_id):
    global events, id, timer, title
    file   = open(os.path.join('stages', 'stage'+str(stage_id)), 'r')
    id     = stage_id
    timer  = -200
    title  = file.readline().rstrip()
    lines  = file.readlines()
    events = []
    for line in lines:
        data = line.split()
        if len(data) == 2:
            events+=[Waiter(int(data[0]), data[1])]
        elif len(data) == 3:
            events+=[Special(int(data[0]), data[1], int(data[2]))]
        elif len(data) == 4:
            events+=[Summon(int(data[0]), data[1], (int(data[2]), int(data[3])))]
    enemy.init()

def update():
    global events, id, timer
    timer += 1
    
    if len(events) == 0:
        if enemy.quantity() == 0:
            load(id+1)
        
        return
    
    while timer == events[0].timer:
        if events[0].name == "wait":
            if enemy.quantity() > 0:
                timer-=1
                return
        events[0].act()
        events.pop(0)
        if len(events) == 0:
            return
    
    #load(id+1)

def draw():
    global id, timer, title
    if timer < 0:
        graphic.write_centered("Stage "+str(id), graphic.screen, (200, 150), graphic.font_title_1, (150,0,0))
        graphic.write_centered(title,            graphic.screen, (200, 200), graphic.font_title_2, (150,0,0))

def init():
    global specials
    
    specials = [special0, special1, special2, special3]